/*

  util.c - utility functions used by WordNet code

*/

#include <stdio.h>
#include <string.h>
#include <ctype.h>

/* Binary search - looks for the word passed at the start of a line
   in the file associated with open file descriptor fp, and returns
   a buffer containing the line in the file. */

#define KEY_LEN		256
#define LINE_LEN	8192

char *bin_search(word, fp)
char *word;
FILE *fp;
{
    int c;
    long top,mid,bot,diff;
    char *beglp, *endlp, key[KEY_LEN];
    static char line[LINE_LEN];
    int length;
    diff=666;
    
    sprintf(key,"");

    top=0;
    fseek(fp,0L,2);
    bot=ftell(fp);
    mid=(bot-top)/2;

    while((strcmp(word,key)) && (diff != 0)) {
	fseek(fp,mid-1,0);
	if(mid != 1)
	    while((c=getc(fp))!='\n'  && c != EOF);
	fgets(line, 4096, fp);
	beglp=line;
	endlp=beglp;
	endlp=strchr(endlp,' ');
	strncpy(key,beglp,endlp-beglp);
	length=endlp-beglp;
	endlp=key;
	endlp += length;
	*endlp='\0';
	if(strcmp(key,word) < 0) {
	    top=mid;
	    bot=bot;
	    diff=(bot-top)/2;
	    mid=top+diff;
	}
	if(strcmp(key,word) > 0) {
	    bot=mid;
	    top=top;
	    diff=(bot-top)/2;
	    mid=top+diff;
	}
    }
    
    fclose(fp);
    
    if(!strcmp(key,word))
	return(line);
    else
	return(NULL);
}

/* Count the number of underscore or space separated words in a string. */

int cntwords(s)
char *s;
{
    int wdcnt = 0;

    while (*s) {
	if (*s == '_' || *s == ' ')
	    wdcnt++;
	s++;
    }
    return(++wdcnt);
}


/* Downcase a word and deadjify at the same time */

char *strtolower(word)
char *word;
{
    register char *y;

    y=word;
    while(*y){
	if(isupper(*y))
	    *y=tolower(*y);
	if(*y == '(')
	    *y='\0';
	else
	    y++;
    }
    return(word);
}

/* Replace all occurences of 'from' with 'to' in 'str' */

char *strsubst(str, from, to)
char *str;
char from;
char to;
{
    char *p;
    for (p = str; *p != 0; ++p)
	if (*p == from)
	    *p = to;
    return str;
}

