/*

  wnconsts.h - constants and functions used by all parts of WordNet system

*/

/* $Id: wnconsts.h,v 1.13 92/03/26 14:45:43 wn Exp $ */

#ifndef _WNCONSTS.H
#define _WNCONSTS.H

#ifdef PC
#define DEFAULTPATH	"c:\\wordnet"
#else
#define DEFAULTPATH	"/usr/local/lib/wordnet"
#endif

#define DEFON 1
#define DEFOFF 0

#define MAXPTR		17
#define MAXSEARCH       23

#define ANTPTR           1	/* ! */
#define HYPERPTR         2	/* @ */
#define HYPOPTR          3	/* ~ */
#define ENTAILPTR        4	/* * */
#define SIMPTR           5	/* & */

#define ISMEMBERPTR      6	/* %m */
#define ISSTUFFPTR       7	/* %s */
#define ISPARTPTR        8	/* %p */

#define HASMEMBERPTR     9	/* #m */
#define HASSTUFFPTR     10	/* #s */
#define HASPARTPTR      11	/* #p */

#define MERONYM         12	/* # */
#define HOLONYM         13	/* % */
#define CAUSETO         14	/* > */
#define CAUSEDBY        15	/* not used (<) */
#define SEEALSOPTR	16	/* ^ */
#define PERTPTR		17	/* \ */

#define SYNS            (MAXPTR + 1)
#define FREQ            (MAXPTR + 2)
#define FRAMES          (MAXPTR + 3)
#define COORDS          (MAXPTR + 4)
#define HMERONYM        (MAXPTR + 5)
#define HHOLONYM	(MAXPTR + 6)

#define FINDBUFSIZE	8192

#define NUMPARTS	3	/* number of parts of speech */
#define NUMFRAMES	33	/* number of verb frames */

#define NOUNSS          1
#define VERBSS          2
#define ADJSS           3

#define FANSS		4	/* not really a part of speech */

/* Generic names for part of speech */

#define NOUN		1
#define VERB		2
#define ADJ		3

#define bit(n) (1<<(n))

/* Adjective markers */

#define PADJ		1	/* (p) */
#define NPADJ		2	/* (n) */
#define IPADJ		3	/* (ip) */

#define UNKNOWN_MARKER		0
#define ATTRIBUTIVE		PADJ
#define IMMED_POSTNOMINAL	NPADJ
#define PREDICATIVE		IPADJ

#endif				/* _WNCONSTS.H */

/*
  Revision log:

  $Log:	wnconsts.h,v $
 * Revision 1.13  92/03/26  14:45:43  wn
 * removed search_cmd
 * 
 * Revision 1.12  92/03/26  12:59:17  wn
 * removed unused pointers - V2NSPTR, N2VSPTR, ASPECT*PTR
 * 
 * Revision 1.11  92/03/24  14:56:33  wn
 * removed BRACKET
 * 
 * Revision 1.10  92/03/04  15:00:59  wn
 * added HHOLONYM search
 * 
 * Revision 1.9  92/02/25  14:39:58  wn
 * added DEFAULTPATH
 * 
 * Revision 1.8  92/02/05  11:06:21  wn
 * added defines for NOUN VERB ADJ
 * 
 * Revision 1.7  91/12/18  11:55:40  wn
 * removed function definitions (moved to search.h)
 * 
 * Revision 1.6  91/12/13  15:24:34  wn
 * renamed from find.h
 * removed things that were specific to search code and added some
 * general things used by all parts of wn software`
 * 

*/
